/***************************************************************************
                          viswidget.h  -  description
                             -------------------
    begin                : Die Jan 7 2003
    copyright            : (C) 2003 by Mark Kretschmann
    email                :
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VISWIDGET_H
#define VISWIDGET_H

#include <qframe.h>
#include <vector>

class QMouseEvent;
class QPixmap;
class QWidget;

#define SINVEC_SIZE 6000

/**
 *@author mark
 */

class VisWidget : public QFrame
{
    Q_OBJECT

    public:
        VisWidget(QWidget *parent=0, const char *name=0);
        virtual ~VisWidget();

        virtual void drawAnalyzer( std::vector<float> * );

    public slots:

    signals:
        void clicked();

    protected:
        virtual void polish();
        virtual void init();
        virtual void initGrid();
        virtual void initSin( std::vector<float> & );

        void interpolate( std::vector<float> *, std::vector<float> & );
        virtual void mouseReleaseEvent( QMouseEvent* );

    // ATTRIBUTES:
        uint m_iVisHeight;
        QPixmap *m_pBgPixmap;
        QPixmap *m_pSrcPixmap;
        QPixmap *m_pComposePixmap;
        QPixmap *m_pGridPixmap;
        QPixmap *m_pRoofPixmap;
};
#endif
